import os
import shutil, errno
from distutils.errors import DistutilsFileError
from distutils.dir_util import copy_tree
from pkg_resources import resource_filename
import subprocess
import sys
import requests

def copy(src, dst):
    try:
        copy_tree(src, dst)
    except DistutilsFileError: 
        shutil.copy(src, dst)

def get_path(path):
    return os.path.abspath(resource_filename('matchmaker', path))

def dress_directory(dirpath):
    return os.path.join(dirpath,"")

def undress_directory(dirpath):
    return os.path.normpath(dirpath)


def rep_mysty(file):

    styp=get_path('core')+"/my.sty"
    #styp="../core/my.sty"
    ln=len(styp)
    mt=ln//2
    fr=styp[:mt]
    ls=styp[mt:ln]
    in_file=open(file, 'r')
    ot_file=open('aux.dat', 'w')
    for line in in_file:
        if 'my.sty' in line:
            ot_file.write(" style= "+ "'" + fr +"'" + "\n")
            ot_file.write("'"+ls +"'"+" ;" + "\n")
        else:
            ot_file.write(line)
    ot_file.close()
    in_file.close()
    shutil.copyfile('aux.dat', file)
    os.remove('aux.dat') 

def rp(fname):
    corepre=get_path('core')+"/"
    filename=corepre+fname
    with open(filename) as f:
        s = f.read()
        if 'REPLACEPATH' not in s:
            return

    with open(filename, 'w') as f:
        s = s.replace('REPLACEPATH', dress_directory(get_path('')))
        f.write(s)

def fix_math_path():
    coredir=get_path("core")
    getmathpath=os.path.join(coredir,"getmathpath.m")
    if sys.version_info<(2,7,0):
        print("python version too old, you need python 2.7 or higher")
    elif sys.version_info<(3,0,0):
        mathoutput=(subprocess.check_output("math -run -noprompt < "+getmathpath,shell=True)).rstrip()
    else:
        mathoutput=subprocess.getoutput("math -run -noprompt < "+getmathpath)
    dir=(mathoutput.split("\n")[0]).replace('"','')
    if coredir not in mathoutput:
        with open(dir.replace('"',''),"a") as myfile:
            myfile.write('$Path = Join[{"'+coredir+'"}, $Path]\n')


def download_models(file_path):
    url = 'https://cafpe.ugr.es/software/MatchMaker/MatchMaker.tar.gz'
    r = requests.get(url, stream=True)
    with open(os.path.join(file_path,"MatchMaker.tar.gz"), 'wb') as f:
        f.write(r.content)

def check_executable(code):
    try:
        subprocess.check_output(code)
        print(code+" properly installed in the system")
    except OSError as e:
        print(code+" does not seem to be in your path, please install it before matching any model")
